/*******************************************************************************
 * Copyright 2011 Danny Kunz
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.omnaest.utils.tuple;

/**
 * A {@link Tuple} is the marker interface for generic wrapper classes holding arbitrary elements of different numbers.<br>
 * <br>
 * A {@link Tuple} derived type should support {@link #hashCode()} and {@link #equals(Object)} as well as {@link #toString()}. Two
 * {@link Tuple} are taken as equal, if their elements are equal and in the same number and order.
 * 
 * @see TupleTwo
 * @see TupleThree
 * @author Omnaest
 */
public interface Tuple
{
  
}
